%setup_python_subpackage apache2_mod_python
%define modname mod_python
%define module_name python

%define a2_version 2.2.4-alt15

%define python_bindir %a_htdocsdir/%module_name
Name: apache2-mod_python%__python_package_version
Version: 3.3.1
Release: alt2.3

Summary: Python module for Apache2
Group: System/Servers
License: Free
Url: http://www.modpython.org
Packager: Alexey Morsov <swi@altlinux.ru>

Source: %modname-%version.tgz
Source1: python.load
Source2: python.conf
Source3: python.start

BuildRequires: flex python-dev python-modules-encodings
BuildRequires: apache2-devel >= %a2_version
BuildRequires: rpm-build-python >= 0.21-alt1
BuildRequires: python-base >= 2.4.4

Requires: python = %__python_version
Requires: apache2 >= %a2_version

Conflicts: mod_python
Provides: mod_python%__python_version

%add_python_req_skip _apache
%add_python_req_skip _psp


%description
mod_python is an Apache2 module that embeds the Python interpreter within the server.
With mod_python you can write web-based applications in Python that will run many
times faster than traditional CGI and will have access to advanced features such as
ability to retain database connections and other data between hits and access to
Apache internals.

%prep
%setup -q -n %modname-%version

%build
%configure --with-apxs=%apache_apxs --prefix=%prefix --with-python-bin=%__python
%make OPT="-fPIC $RPM_OPT_FLAGS -DEAPI" dso

%install
install -d -m 755 -- $RPM_BUILD_ROOT%a_mods_available
install -d -m 755 -- $RPM_BUILD_ROOT%a_mods_start
install -d -m 755 -- $RPM_BUILD_ROOT%a_libexecdir
install -d -m 755 -- $RPM_BUILD_ROOT%a_addondocdir/%modname

install -p -m 644 -- %SOURCE1 $RPM_BUILD_ROOT%a_mods_available/%module_name.load
install -p -m 644 -- %SOURCE2 $RPM_BUILD_ROOT%a_mods_available/%module_name.conf
subst 's,@a_libexecdir@,%a_libexecdir,g' $RPM_BUILD_ROOT%a_mods_available/%module_name.load
subst 's,@python_bindir@,%python_bindir,g' $RPM_BUILD_ROOT%a_mods_available/%module_name.conf
install -p -m 644 -- %SOURCE3 $RPM_BUILD_ROOT%a_mods_start/100-%module_name.conf

mkdir -p %buildroot{%python_sitelibdir/%modname,%_docdir/%modname-%version/icons,%python_bindir,\
%a_cgidir}

%__install -c src/%modname.so %buildroot%a_libexecdir

for i in `ls lib/python/%modname/*.py`; do
  %__install -m 0644 $i %buildroot%python_sitelibdir/%modname;
done

# docs
for i in `ls doc-html/*.html doc-html/*.css`; do
  %__install -m 0644 $i %buildroot%_docdir/%modname-%version;
done
for i in `ls doc-html/icons/*.gif`; do
  %__install -m 0644 $i %buildroot%_docdir/%modname-%version/icons;
done

%__ln_s %_docdir/%modname-%version %buildroot%a_addondocdir/%modname

### Creating mptest.py
%__cat <<EOF >mptest.py
from mod_python import apache

def handler(req):
    req.send_http_header()
    req.write("Hello World!")
    return apache.OK
EOF

#%__install -m 0644 A.%modname.conf %buildroot%apache_addonconfdir/
%__install -m 0644 mptest.py %buildroot%python_bindir/

%post
# Reconfigure Apache2:
%a_sbindir/a2chkconfig ||:

if [ -e %a_mods_enabled/%module_name.load ]; then
    CONF_OK=0
    %a_sbindir/apachectl2 configtest && CONF_OK=1 ||:
    if [ "$CONF_OK" = "1" ]; then
        service %a_dname condrestart ||:
    else
        echo "Some errors detected in Apache2 configuration!"
        echo "To use %modname check configuration and start %a_dname service."
    echo
    fi
else
    echo "Apache2 %modname module had been installed, but does't enabled."
    echo "Check %a_mods_start directory for files with '%module_name=no' lines."
    echo
fi

%preun
if [ "$1" = "0" ] ; then # last uninstall
    [ -e %a_mods_enabled/%module_name.load ] && %a_sbindir/a2dismod %module_name 2>&1 >/dev/null ||:
fi



%postun
# Reconfigure Apache2:
%a_sbindir/a2chkconfig ||:
if [ "$1" = "0" ] ; then # last uninstall
    CONF_OK=0
    %a_sbindir/apachectl2 configtest && CONF_OK=1 ||:
    if [ "$CONF_OK" = "1" ]; then
	service %a_dname condrestart ||:
    else
        echo "Some errors detected in Apache2 configuration!"
	echo "To complete %module_name uninstalling check configuration and restart %a_dname service."
	echo
    fi
fi



%files
%python_sitelibdir/%modname/*
%a_libexecdir/%modname.so
%dir %attr(0775,root,%apache_webmaster) %python_bindir
%attr(0664,root,%apache_webmaster) %python_bindir/mptest.py*
%config(noreplace) %a_mods_available/%module_name.conf
%config            %a_mods_available/%module_name.load
%config            %a_mods_start/100-%module_name.conf
%a_addondocdir/*
%doc %_docdir/%modname-%version/*

%changelog
* Mon Apr 09 2007 Alexey Morsov <swi@altlinux.ru> 3.3.1-alt2.3
- fix version requires for apache2

* Wed Apr 04 2007 Alexey Morsov <swi@altlinux.ru> 3.3.1-alt2.2
- fix build requires for new python policy

* Mon Apr 02 2007 Alexey Morsov <swi@altlinux.ru> 3.3.1-alt2.1
- fix uninstall, config 

* Mon Apr 02 2007 Alexey Morsov <swi@altlinux.ru> 3.3.1-alt2
- Switch to the new Apache2 configuration scheme
- Spec file cleanup

* Tue Mar 06 2007 Alexey Morsov <swi@altlinux.ru> 3.3.1-alt1
- new version (bugfixed, improvements, new features)

* Wed Jan 10 2007 Alexey Morsov <swi@altlinux.ru> 3.2.10-alt2
- make this mod_python conflicts with mod_python for apache1.3
  otherwise not possible to start any apps without patching them
	for s/mod_python/apache2_mod_python/

* Wed Dec 20 2006 Alexey Morsov <swi@altlinux.ru> 3.2.10-alt1.1
- fix spec

* Thu Dec 07 2006 Alexey Morsov <swi@altlinux.ru> 3.2.10-alt1
- Initial build for Sisyphus
- patch for separate apache2-mod_python from mod_python for apache1

